/* $Id: Interval.java,v 1.3 2004/01/10 13:09:18 mit Exp $ */	
/* Interval.java v2.0 (all) */
public class Interval{
    private final int LWB = 0;
    private final int HIB = 1;
    private final int NAM = 2;
    private final int unison = 0;
    private final int i2nd = 1, j2nd = 2;
    private final int i3rd = 3, j3rd = 4;
    private final int p4th = 5, d5th = 6;
    private final int p5th = 7;
    private final int i6th = 8, j6th = 9;
    private final int i7th = 10,j7th = 11;
    private final int octave = 12;
    private final int tenth = 16, twelfth = 19;
    private final int octave2 = 24;
    private final int oct10th = 28, oct12th = 31;
    private final int octave3 = 36;
    private final int [] intnm = {
	unison,
	i2nd, j2nd, i3rd, j3rd, 
	p4th, d5th, p5th,
	i6th, j6th, i7th, j7th, 
	octave, tenth, twelfth,
	octave2, oct10th, oct12th, octave3};
    private final String [] inter = {
	"unison",
	"mi.2nd","Mj.2nd","mi.3rd","Mj.3rd",
	"P.4th","Dim.5th","P.5th",
	"mi.6th","Mj.6th","mi.7th","Mj.7th",
	"Octave","10th","12th",
	"2octave","Oct.10th","Oct.12th","3octave"};
    final int [][] ratio = {                 // interval
	{2, 1, octave}, {4, 2, octave}, {6, 3, octave},
	{8, 4, octave}, {10, 5, octave},{12, 6, octave},
	{16, 15, i2nd}, {12, 11, i2nd},  
	{9, 8, j2nd},   {10, 9, j2nd},
	{6, 5, i3rd},   {7, 6, i3rd}, {5, 4, j3rd},
	{4, 3, p4th},   {8, 6, p4th}, // $B%5%$%7%g%r(Blaying$B%G%7%h%&(B
	{7, 5, d5th},   {11, 8, d5th},
	{3, 2, p5th},   {6, 4, p5th}, // " & octave
	{8, 5, i6th},   {5, 3, j6th},
	{7, 4, i7th},   {9, 5, i7th}, {16, 9, i7th},
	{15, 8, j7th},
	{5, 2, tenth},  {3, 1, twelfth},
	{4, 1, octave2},{5, 1, oct10th},
	{6, 1, oct12th},{8, 1, octave3}, 
	{1, 1, unison}};
    public Interval() {

    }
    public int getInum() {
	return ratio.length;
    }
    public int getIinte(int v) {
	for (int i = 0; i < ratio.length; i++) {
	    if (ratio[i][NAM] == v)
		return i;
	}                // $B%5%$%7%g%N%[%&%r%H%k(B
	return -1;
    }
    public String getIinter(int v) {
	v = Math.abs(v);
	for (int i = 0; i < intnm.length; i++) {
	    if (intnm[i] == v)
		return inter[i];
	}
	return "";
    }
    public String getIname(int n) {
	for (int i = 0; i < intnm.length; i++) {
	    if (ratio[n][NAM] == intnm[i])
		return inter[i];
	}
	return "";
    }
    public int getIlow(int n) {
	return ratio[n][LWB];
    }
    public int getIhigh(int n) {
	return ratio[n][HIB];
    }
    public int getIvalue(int n) {
	return ratio[n][NAM];
    }
    public String toString(int n) {
	return (this.getIname(n)+" "+ratio[n][LWB]+":"+ratio[n][HIB]);
    }
}
