/* $Id: MakeWaves.java,v 1.2 2012/05/31 00:43:56 mit Exp $ */
/* MakeWaves.java v0.1 */

public class MakeWaves {
    private final int KB = 88;
    private final int SP88 = 22; // 1/22
    private final int SP49 = 8;  // 1/8
    private final int K49 = 49-1;
    private final int SA =  KB-K49-1;
    private final double SAQ = Math.pow(SP88/(double)SP49, 1.0/SA);
    private final double CutoffL = 20.0;  // [Hz]
    private final double CutoffH = 170.0; //  "
    private final double PI2 = 2.0*Math.PI;

    private int Splgf;
    private int Multi;
    private int Key;
    private int MaxData;   // SplgfxTime
    private double TD;     // 1.0/Splgf;
    private double[] Wave;

    public void getWaves(int splf, int mult, int key, double time,
			 double[] freq, boolean sw) {
	Splgf = splf;
	Multi = mult;
	Key = key;
	TD = 1.0/Splgf;
	MaxData = (int)(Splgf*time);

	calc(sw, freq, time);
    }
    public void getWaves(int splf, int mult, int key, double time, 
			 double freq, boolean sw) {
	Splgf = splf;
	Multi = mult;
	Key = key;
	TD = 1.0/Splgf;
	MaxData = (int)(Splgf*time);

	calc(sw, freq, time);
    }
    public double getWave(int nm) {
	return Wave[nm];
    }
    public void calc(boolean sw, double freq, double time) {
	if (sw) /* falsewaveǡξ.ǽtrue */
	    Wave = new double[MaxData];

	double ksp = calc_sindo(freq, Multi);
	double t = 0;
	for (int i = 0; i < MaxData; i++){
	    Wave[i] += Math.sin(freq*t*PI2)*ksp*Math.exp(-t*time);
	    t += TD;
	}
    }
    public void calc(boolean sw, double[] freq, double time) {
	double t, ksp;
	int i, j;
	if (sw) /* falsewaveǡξ.ǽtrue */
	    Wave = new double[MaxData];

	for (j = 1; j <= Multi; j++) {
	    ksp = calc_sindo(freq[j], j);
	    t = 0;
	    for (i = 0; i < MaxData; i++){
		Wave[i] += Math.sin(freq[j]*t*PI2)*ksp*Math.exp(-t*time);
		t += TD;
	    }
	}
    }
    public double calc_sindo(double freq, int pr) {
        double fg = get_sboard(freq);
        double sp = get_spoint();
        double ga = spoint(pr, sp);

        return ga*fg;
    }
    public double get_spoint() { // 0~481/8
        return (Key <= K49) ? (double)SP49 : SP49*Math.pow(SAQ, Key-K49);
    }
    public double spoint(int mm, double sp) {
        double mp = mm * Math.PI;
        return Math.abs(8.0*Math.sin(mp/sp)/mp); // ̵· 8
    }
    public double get_sboard(double freq) {
	freq -= CutoffL;
        double gain = freq/CutoffH;

        if (gain < 0)
            gain = 0.0;
        else if (gain > 1.0)
            gain = 1.0;

        return gain;
    }
}
