/* $Id: keyboard.java,v 1.93 2013/02/07 00:50:04 mit Exp $
/* keyboard.java v0.9.1 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.DecimalFormat;

public class keyboard extends Applet 
    implements MouseListener, MouseMotionListener,
	       ActionListener, AdjustmentListener, ItemListener, Runnable
{
    private Button btM, btP;   // -,+
    private Button btKEYBD;
    private Button btDATA;
    private Button[] btGraph;
    private Button btTune;     // tune-clear
    private Button btItype;
    private Scrollbar sbKey;   // key size
    private Scrollbar sbWide;  // width
    private Scrollbar sbValue; // value
    private Scrollbar sbTune;  // for tune
    private Scrollbar sbInhar;
    private Scrollbar sbGrade;
    private TextField tfA;
    private Label lbInha;
    private Label lbGrad;
    private Label lbBeat;
    private Choice chMulti;
    private Choice chSmpl;
    private Choice chBand;
    private Canvas can;
    private Thread thr;
    private Panel PU, PS, PW, PE;

    final int OCT = 12;
    final int OCT2 = OCT*2;
    final int KB = OCT*7+4;  // 88
    final int CENT = 0;   // for GRAPH
    final int BEAT = 1;
    final int FFT_ = 2;
    final int IFFT = 3;
    final int WAVE = 4;
    final int INHA = 5;
    final int WVCL = 1;   // for calc. sw
    final int FFCL = 2;
    final int BTCL = 4;
    final int Wend = 28;  // 
    final double PI2 = Math.PI*2;
    final double Log10 = Math.log(10);  // for inha.
    final String[] Graph = {"Cent", "Beats", "FFT", "IFFT", "Wave", "Inha."};
    final String[] Spnm = {"9","10","11","12","13","14"};
    final String[] Band = {"5", "9", "17", "33", "65"};

    boolean KeybdSW; // keyboard sw.
    boolean DataSW;  // data sw.
    boolean RunSW;   // first run
    boolean Itype;   // inha. type
    boolean MouseSW; // mouse move
    boolean TuneSW;  // tune-clear
    boolean CalcSW;  // make wave
    boolean FftSW;   // calc fft
    int W;
    int H;
    int HH;
    int HS;
    int FNT;
    int KN;         // key#
    int KO;         // pre key#
    int mX;         // mouse x
    int mY;         // " y
    int AA = 440;
    int Maxp;       // max partial(30)
    int Minp;       // min "#
    int GRAPH = CENT; // graph sw.
    int Wide;       // band width
    int Sift;       // band sift
    int SP = 22050; // 44100, 22050, 11025, 8000
    int SPH = SP/2;
    int N0 = 13;    // (12-4096 13-8192 14-16384 15-32768)
    int N;          // Math.pow(2,N0);
    int NH;         // N/2
    int Maxd;       // sec*sp
    int GradSave;   // gradeؤ¸
    int BandN;      // for ifft
    int FF;         // fft num.
    double SEC;     // 2.0 wave data time
    double Minb;    // min beats
    double mC;      // mouse cent
    double TD;      // sec/sp
    double DW;      // mx/w
    double DS;      // w/sph
    double Time;    // wave time
    String Error;
    Color dimGray = new Color(90, 90, 90);
    double[] Bgf;   // beats
    double[] Slf;   // "
    double[] Unari; // beat
    double[] Han;   // hanning
    double[] RE;    // fft
    double[] IM;    // "
    double[] DT;    // "
    double[] InhaTK;
    double[] InhaTF;

    Font Fnt, Fns;
    FontMetrics fm;
    Graphics gi;
    Image im;
    DecimalFormat df1;

    Keyboard[] K;
    Interval I;
    FFT fftN;
    TuningFormula2 TF2;
    TuningKeys TK;
    MakeWaves MW;
    Square[] SQK; // for scrollbar
    Square[] SQV; //  "

    public void init() {
	String fnt = getParameter("font");
	FNT = (fnt != null) ? Integer.parseInt(fnt) : 12; //
	Fnt = new Font("SansSerif", Font.PLAIN, FNT);
	Fns = new Font("SansSerif", Font.PLAIN, FNT);
	setFont(Fnt);
	fm = getFontMetrics(Fnt);
	df1 = new DecimalFormat("#0.0##");

	buildLayout();
	init_data();
	set_enabled();
    }
    public void buildLayout() {
        setBackground(Color.lightGray);
	setLayout(new BorderLayout());

	PU = new Panel();
	PU.setLayout(new FlowLayout());
        add(PU, "North");

	tfA = new TextField(32);
        tfA.setFont(Fns);
        tfA.setEditable(false);
        tfA.addActionListener(this);
        PU.add(tfA);

	chBand = new Choice();
	for (int i = 0; i < Band.length; i++)
	    chBand.addItem(Band[i]);
	PU.add(chBand);
	chBand.addItemListener(this);
        chBand.select(Band[2]);
	BandN = 16;

	btM = new Button("<");
        btM.addActionListener(this);
        PU.add(btM);

        btP = new Button(">");
        btP.addActionListener(this);
        PU.add(btP);

	chMulti = new Choice();
        for (int i = 0; i < 30; i++)
            chMulti.addItem(""+(i+1));
        PU.add(chMulti);
        chMulti.addItemListener(this);
	Maxp = 16;
	chMulti.select(""+Maxp);

	PU.add(new Label(":Mult."));

	chSmpl = new Choice();
        for (int i = 0; i < Spnm.length; i++)
            chSmpl.addItem(Spnm[i]);
        PU.add(chSmpl);
        chSmpl.addItemListener(this);
        chSmpl.select(""+N0);         //  13

	PU.add(new Label(":Samp."));
	//-----------------

	PW = new Panel();
        PW.setLayout(new GridLayout(1,2,0,0));
        add(PW, "West");

	Panel w1 = new Panel();
	w1.setLayout(new GridLayout(Graph.length+2,1,0,0));
	PW.add(w1);

	btKEYBD = new Button("Key");
	btKEYBD.addActionListener(this);
        w1.add(btKEYBD);

	btDATA = new Button("Data");
	btDATA.addActionListener(this);
        w1.add(btDATA);

	btGraph = new Button[Graph.length];
        for (int i = 0; i < Graph.length; i++) {
            btGraph[i] = new Button(Graph[i]);
            btGraph[i].addActionListener(this);
            w1.add(btGraph[i]);
	}
	//----------------

	PE = new Panel();
        PE.setLayout(new GridLayout(2,1,0,0));
        add(PE, "East");

	sbKey = new Scrollbar(Scrollbar.VERTICAL, 0, 100, 200, 1100);
        PE.add(sbKey);
        sbKey.addAdjustmentListener(this);

	sbValue = new Scrollbar(Scrollbar.VERTICAL,50,1,1,100);
        PE.add(sbValue);
        sbValue.addAdjustmentListener(this);
	//-----------------

	PS = new Panel();
        PS.setLayout(new GridLayout(2,1,0,0));
        add(PS, "South");

	Panel s0 = new Panel();
	s0.setLayout(new GridLayout(1,2,0,0));
	PS.add(s0);

	Panel s1 = new Panel();
	s1.setLayout(new GridLayout(1,2,0,0));
	s0.add(s1);

	btTune = new Button("Clear");
        btTune.addActionListener(this);
        s1.add(btTune);

	btItype = new Button("Curved ");
        btItype.addActionListener(this);
        s1.add(btItype);

	sbWide = new Scrollbar(Scrollbar.HORIZONTAL, 50, 10, 20, 100);
        s0.add(sbWide);
        sbWide.addAdjustmentListener(this);

	Panel s2 = new Panel();
	s2.setLayout(new GridLayout(1,6,0,0));
	PS.add(s2);

	GradSave = 28; // Straight
	sbGrade = new Scrollbar(Scrollbar.HORIZONTAL, 87, 1, 0, 121);
        s2.add(sbGrade);
        sbGrade.addAdjustmentListener(this);

	lbGrad = new Label(" Grade:");
	s2.add(lbGrad);

	sbInhar = new Scrollbar(Scrollbar.HORIZONTAL, 55, 1, 1, 101); // 0.01~1.0
        s2.add(sbInhar);
        sbInhar.addAdjustmentListener(this);

	lbInha = new Label(" Inhar.:");
	s2.add(lbInha);

	sbTune = new Scrollbar(Scrollbar.HORIZONTAL, 10, 1, 0, 21);
        s2.add(sbTune);
        sbTune.addAdjustmentListener(this);

	lbBeat = new Label(" Beat:");
	s2.add(lbBeat);
	//-------------------

	can = new MyCanvas();
	add(can, "Center");

	can.addMouseListener(this);
	can.addMouseMotionListener(this);
    }
    public void set_enabled() {
	boolean isw = (GRAPH == INHA);
	sbValue.setEnabled(!isw);

	boolean fsw = (GRAPH == FFT_);
	chSmpl.setEnabled(fsw);

	boolean rsw = (GRAPH == IFFT);
	chBand.setEnabled(fsw || rsw);
    }
    public void init_data() {
	I = new Interval();
        TF2 = new TuningFormula2();
        TK = new TuningKeys(KB);
	MW = new MakeWaves();
	SQK = new Square[Graph.length];
	SQV = new Square[Graph.length];

	init_multi();
	set_nn();

	K = new Keyboard[KB];
	SEC = 2.0;
	TD = SEC/SP;
	Maxd = (int)(SP*SEC);

	chMulti.select(Maxp-1);
	set_keyboard();
    }
    public void init_multi() {
	Bgf = new double[Maxp+1];
	Slf = new double[Maxp+1];
	Unari = new double[Maxp+1];
    }
    public void start() {
	W = getCanvasD().width;
        H = getCanvasD().height;

	HH = H/2;
	HS = H-FNT*2;
	can.setSize(W, H);
	im = createImage(W, H);
        gi = im.getGraphics();
        gi.setFont(Fnt);
	Error = "";

	if (!RunSW) {     // Τߥå
	    KN = OCT*4;   // 49-1;
	    KO = OCT*3;   // 37-1;
	    RunSW = true; // run sw.

	    init_tune();
	    set_key_scroll();
	    set_vscroll();
	    write_GIB();
	}
    }
    public void destroy() {
	K[0].setReStart();
	for (int i = 0; i < KB; i++)
	    K[i].setClear();
    }
    public Dimension getCanvasD() {
	Dimension dw = PW.getSize();
	Dimension de = PE.getSize();
        Dimension ds = PS.getSize();
	Dimension dn = PU.getSize();
	Dimension da = getSize();
	int cw = da.width-(de.width+dw.width);
        int ch = da.height-(dn.height+ds.height);
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void init_tune() {
	InhaTF = TF2.getInha();
        TF2.getCurve(1.0);

        InhaTK = TK.makeInha();
    }
    public void make_tune() {
	if (Itype)  // Straight
	    InhaTK = TK.makeInha(Wend, getInhar(), getGrad());
	else       // Curve
	    InhaTF = TF2.getInharmonicity(Wend, getInhar(), getGrad());
    }
    public double getInhar() {
	return sbInhar.getValue()/100.0;
    }
    public double getGrad() {
	return Itype ? sbGrade.getValue()/10.0 : sbGrade.getValue()/1000.0;
    }
    public double getUnari() {
	return sbTune.getValue()/10.0;
    }
    public void rerun() {
	TuneSW = !TuneSW;

	if (TuneSW)
	    clear_cent();
	else {
	    make_tune();

	    if (Itype) { // Straight
		TK.startRun(getUnari(), Wend, getInhar(), getGrad());

		thr = new Thread(this);
		thr.start();
	    } else
		TF2.getCurve(getUnari());
	}

	CalcSW = false;
	btTune.setLabel(TuneSW ? "Tune " : "Clear");
    }
    public void set_key_scroll() {
	int min = (int)(1000.0*W/K[0].getMaxX()); // ץκǾ
	int max = (int)(1000.0*W/(OCT2*8*2));     // 2֥
	sbKey.setValues(min,100,min,max+100);
    }
    public void set_keyboard() {
	for (int i = 0; i < KB; i++)
	    K[i] = new Keyboard(1, 10, 'A', false);
	/* x, y, Υ̾, on/off */
    }
    //
    public void set_cent(int key, double c) {
	if (Itype)
	    TK.setCent(key, c);
	else
	    TF2.setCent(key, c);
    }
    public double getf(int key, int pr) {
	return Itype ? TK.getIfreq(key, pr) : TF2.get_ifreq(key, pr);
    }
    public double getc(int key, int pr) {
	return Itype ? TK.getIcent(key, pr) : TF2.get_icent(key, pr);
    }
    public double geti(int key) {
	return Itype ? InhaTK[key] : InhaTF[key]; 
    }
    //
    public String dform(double val) {
	return df1.format((float)val);
    }
    //
    public void run() {
        int stime = 80;
	try {
            while (TK.isRun()) {
                can.repaint();
                thr.sleep(stime);
            }
        } catch (InterruptedException e) {
            System.out.println(e);
        }

	thr = null;
        can.repaint();
    }

    public void mouseDragged(MouseEvent me) {
	if (GRAPH == CENT || GRAPH == BEAT || GRAPH == FFT_ ||
	    GRAPH == IFFT || GRAPH == WAVE) {
	    int my = me.getY();
      	    double mc = (mY-my)/10d;
	    set_cent(KN, mc+mC);

	    CalcSW = false;
	    can.repaint();
	}
    }
    public void mouseMoved(MouseEvent me) {
	switch (GRAPH) {
	case FFT_:
	    if (MouseSW) {
		mX = me.getX();
		setFF();
		can.repaint();
	    }
	    break;
	case WAVE:
	    DW = me.getX()/(double)W;
	    can.repaint();
	    break;
	default:
	}
    }
    public void setFF() {
	FF = getFF(NH*get_sbv());
    }
    public void mousePressed(MouseEvent m) {
	if (GRAPH == FFT_)
	    MouseSW = !MouseSW;

	mX = m.getX();
	mY = m.getY();
	keySelect();

	mC = getc(KN, 1); // for dragg
	can.repaint();
    }
    public void keySelect() {
	for (int i = 0; i < KB; i++) {
	    if (K[i].isInside(mX,mY)) {
		K[i].setSW(true);
		KO = KN;
		KN = i;

		CalcSW = false;
	    } else
		K[i].setSW(false);
	}
    }
    public void mouseClicked(MouseEvent m) {}
    public void mouseReleased(MouseEvent m){}
    public void mouseEntered(MouseEvent m) {}
    public void mouseExited(MouseEvent m) {}

    public void actionPerformed(ActionEvent e) {
	saveScrollbar(SQK, sbKey);
	saveScrollbar(SQV, sbValue);

	for (int i = 0; i < btGraph.length; i++) {
	    if (e.getSource() == btGraph[i]) {
		GRAPH = i;
		break;
	    }
	}
	if (e.getSource() == btM)      // <
            pm_(false);
        else if (e.getSource() == btP) // >
            pm_(true);

	else if (e.getSource() == btKEYBD)
	    KeybdSW = !KeybdSW;

	else if (e.getSource() == btDATA)
	    DataSW = !DataSW;

	else if (e.getSource() == btTune) // tune-clear
	    rerun();

	else if (e.getSource() == btItype) // Inha. type
	    change_type();

	resetScrollbar(SQK, sbKey);
	resetScrollbar(SQV, sbValue);

	on_off_check();
	set_enabled();
	can.repaint();
    }
    public void clear_cent() {
	for (int i = 0; i < KB; i++)
	    set_cent(i, 0);
    }
    public void change_type() {
	int tmp = sbGrade.getValue();

        Itype = !Itype;
        btItype.setLabel(Itype ? "Straight" : "Curved ");
	sbGrade.setMinimum(Itype ? 10 : 0);   // 1 | 0.0
        sbGrade.setMaximum(Itype ? 42 : 121); // 4.1 | 0.12

        sbGrade.setValue(GradSave);
        GradSave = tmp;

	write_GIB();
	rerun();
    }
    public void on_off_check() {
	if (DataSW) {
	    if(KeybdSW)
		DataSW = false;
	} else if (KeybdSW) {
	    if (DataSW)
		KeybdSW = false;
	}
    }
    public int getVolume() {
	return sbValue.getValue();
    }
    public void pm_(boolean sw) {
	KN = sw ? KN+1 : KN-1;
	KO = sw ? KO+1 : KO-1;

	if (KN < 0 || KO < 0) {
	    KN++;
	    KO++;
	} else if (KN >= KB || KO >= KB) {
	    KN--;
	    KO--;
	} else {
	    CalcSW = false;
	}
    }

    public void itemStateChanged(ItemEvent e) {
	if (e.getSource() == chMulti) {            // partial#
            String pa = chMulti.getSelectedItem();
            Maxp = Integer.parseInt(pa);
	    init_multi();

	    CalcSW = false;
        }
	if (e.getSource() == chSmpl) {  // sampling    
            N0 = Integer.parseInt(chSmpl.getSelectedItem());
            set_nn();
        }
	if (e.getSource() == chBand) {
	    BandN = Integer.parseInt(chBand.getSelectedItem());
	}

	can.repaint();
    }
    public void set_nn() {
        N = (int)Math.pow(2, N0);
        NH = N/2;
	fftN = new FFT(N);
	Han = new double[N];
	RE = new double[N];
        IM = new double[N];
        DT = new double[NH];

	initHanning();
	CalcSW = false;
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
	boolean sw = true;
	if (e.getSource() == sbKey) // keyboard
	    set_vscroll();

	else if (e.getSource() == sbWide) // width
	    set_keyx(); 

	else if (e.getSource() == sbTune) // unari
	    sw = false;
	else if (e.getSource() == sbInhar)
	    sw = false;
	else if (e.getSource() == sbGrade)
	    sw = false;
	write_GIB();

	if (sw)
	    can.repaint();
    }
    //
    public void saveScrollbar(Square sq[], Scrollbar sb) {
	if (sq[GRAPH] == null)
	    sq[GRAPH] = new Square(sb);
	else
	    sq[GRAPH].setSquare(sb);
    }
    public void resetScrollbar(Square sq[], Scrollbar sb) {
	if (sq[GRAPH] == null)
	    sq[GRAPH] = new Square(sb);
	else {
	    sq[GRAPH].resetSquare(sb);
	    if (sq == SQK)
		set_vscroll();
	}
    }
    class Square {
	private int val;
	private int wid;
	private int min;
	private int max;

	public Square() {
	    setSquare(0, 0, 0, 0);
	}
	public Square(int a, int b, int c, int d) {
	    setSquare(a, b, c, d);
	}
	public Square(Scrollbar sb) {
	    setSquare(sb);
	}
	public void setSquare(Scrollbar sb) {
	    setSquare(sb.getValue(), sb.getVisibleAmount(),
		      sb.getMinimum(), sb.getMaximum());
	}
	public void setSquare(int a, int b, int c, int d) {
	    val = a;
	    wid = b;
	    min = c;
	    max = d;
	}
	public void resetSquare(Scrollbar sb) {
	    sb.setValues(this.val, this.wid, this.min, this.max);
	}
	public String toString() {
	    StringBuffer sb = new StringBuffer();
	    sb.append("val: "+val);
	    sb.append(" wid: "+wid);
	    sb.append(" min: "+min);
	    sb.append(" max: "+max);

	    return sb.toString();
	}
    }
    //
    public void write_GIB() {
	lbGrad.setText("Grade: "+dform(getGrad()));
	lbInha.setText("Inha.: "+dform(getInhar()));
	lbBeat.setText("Beats: "+dform(getUnari()));

	CalcSW = false;
    }
    public void set_vscroll() {
	double val = sbKey.getValue()/1000.0;
	for (int i = 0; i < KB; i++)
	    K[i].setValue(val);

	set_wscroll();
    }
    public void set_wscroll() {
	int max = (int)K[0].getMaxx();
	sbWide.setValues(sbWide.getValue(), W, 0, max);
	set_keyx();
    }
    public void set_keyx() {
	for (int i = 0; i < KB; i++)
	    K[i].setX(-sbWide.getValue());
    }

    public void write_text() {
	StringBuffer stb = new StringBuffer(80);
	stb.append(get_keyfreq(KN));

	switch(GRAPH) {
	case CENT:
	    stb.append(" C:"+dform(getc(KN, 1))+"[cent]");
	    break;
	case INHA:
	    stb.append(" I:"+dform(geti(KN)));
	    break;
	case BEAT:
	    stb.append(" B:(min)"+dform(Minb));
	    stb.append("("+Minp+")");
	    break;
	case WAVE:
	    stb.append(" W:"+dform(Time)+"[sec]");
	    break;
	case FFT_:
	    stb.append(" F:("+dform(mX/DS)+"[Hz])");
	    break;
	case IFFT:
	    stb.append(" IFFT:");
	    break;
	default:
	}
	stb.append(isInterval());

	tfA.setText(stb.toString());
    }
    public String get_keyfreq(int key) {
	if (key > KB)
	    return "---";

	StringBuffer stb = new StringBuffer(32);
	stb.append((key+1)+"<");
	stb.append(K[0].getKeynm(key)+">"); // ¥ӥ˴Υ
	stb.append(dform(getf(key, 1)));

	return stb.toString();
    }
    public String isInterval() {
	String str = I.getIinter(KO-KN);
	str = (str.length() < 1) ? "" : " ("+str+")";

	return str;
    }
    //-----

    class MyCanvas extends Canvas {
	public void update(Graphics g) {
	    can.paint(g);
	}
	public void paint(Graphics g) {
	    paintI();
	    g.drawImage(im, 0, 0, this);
	}
    }
    public void paintI() {
	gi.setColor(KeybdSW ? Color.black : Color.darkGray);
	gi.fillRect(0, 0, W, H);

	keyOnOff();

	if (!Error.equals(""))
	    return;

	if (!CalcSW) {
	    make_wave();
	    calc_beats();
	    FftSW = false;
	}

	set_band_width();
	if (!DataSW) {
	    switch (GRAPH) {
	    case CENT:
		disp_cent(gi);
		break;
	    case INHA:
		disp_inharmo(gi);
		break;
	    case BEAT:
		disp_beat(gi);
		break;
	    case WAVE:
		disp_wave(gi);
		break;
	    case FFT_:
		disp_fft(gi);
		break;
	    case IFFT:
		disp_ifft(gi);
		break;
	    default:
	    }
	}
	write_text();
	if (thr != null)
	    disp_tuning(gi);

	//showStatus("KeybdSW: "+KeybdSW);
    }
    public void keyOnOff() {
	if (KeybdSW) {
	    switch (GRAPH) {
	    case CENT:
	    case INHA:
		disp_cursor(gi);
		break;
	    case WAVE:
	    case IFFT:
		disp_c_line(gi);
		break;
	    default:
	    }
	} else
	    disp_keyboard(gi);
    }
    //
    public void disp_ifft(Graphics g) {
	double[] wv = setWaveData();
	int stt = (int)wv[0];
	int wid = (int)wv[1];
	double dn = wv[2];
	double val = 200d/getVolume();
	int x, y;

	double[] tmp = calc_ifft();

	g.setColor(Color.cyan);
	for (int i = 0; i < wid; i++) {
	    x = (int)(dn*i);
	    y = (int)(HH-tmp[i+stt]*val);
	    g.drawLine(x, y, x, y);
        }

	disp_time(g, wid);
    }
    public double[] calc_ifft() {
	double[] temp = new double[Maxd];
        int i, j, cnt = 0;
	int devid = (Maxd-NH)/NH+1;
	int f1 = FF-BandN/2;
	int f2 = FF+BandN/2;

	BreakOut:
	for (j = 0; j < devid; j++) {
	    cnt = NH*j;
	    for (i = 0; i < N; i++) {
		if (cnt+i >= Maxd)
		    break BreakOut;
		IM[i] = RE[i] = MW.getWave(cnt+i);
	    }
	    hanning();
	    fftN.fft(RE, IM);

	    for (i = 0; i < N; i++) {
                if (f1 > i || f2 < i)
                    IM[i] = RE[i] = 0;
            }
            fftN.ifft(RE, IM);
            for (i = 0; i < N; i++)
                temp[cnt+i] += RE[i];
        }

        return temp;
    }
    //
    public void disp_fft(Graphics g) {
	if (!FftSW) {
	    gauss();
	    fft();
	}

	double val = 3.0/getVolume();
	double wnmax = NH*get_sbv();
	double dw = (W-1)/wnmax;
	int wd = (dw < 1) ? 1 : (int)dw;
	int f1 = FF-BandN/2;
	int f2 = FF+BandN/2;
	double x, y;

	disp_fft_hline(g, val);
	disp_fft_scale(g);

	for (int i = 0; i < (int)wnmax; i++) {
	    x = dw*i;
	    y = DT[i]*val;

	    setFftColor(g, i, f1, f2);
	    g.fillRect((int)x, (int)(HS-y), wd, (int)y);
	}
    }
    public void setFftColor(Graphics g, int i, int f1, int f2) {
	g.setColor((f1 > i || f2 < i) ? Color.green : Color.white);
    }
    public int getFF(double max) {
	return (int)(mX*(max/(double)W));
    }
    public double get_sbv() {
	return Math.pow(sbKey.getMinimum()/(double)sbKey.getValue(),2);
    }
    public void disp_fft_hline(Graphics g, double val) {
	double dh, hy, bmax = HS/val;
	double hx = bmax/10;
	int hp, hm, xs = 2;
        for (int i = 1; i <= 10; i++) {
            dh = hx*i;
            hy = val*dh;
            hm = (int)(HS-hy);

            g.setColor(dimGray);
            g.drawLine(0, hm, W-1, hm);
        }

	g.setColor(Color.gray);
        g.drawLine(0, HS, W, HS);
    }
    public void disp_fft_scale(Graphics g) {
	int di, me;
	double wsmax = SPH*get_sbv();
	DS = (W-1)/wsmax;

	for (int i = 0; i < (int)wsmax; i += 10) {
	    if (i%10000 == 0) {
                me = 20;
                if (wsmax >= 10000)
                    disp_k(g, i);
            } else if (i%5000 == 0) {
                me = 17;
                if (wsmax >= 5000)
                    disp_k(g, i);
            } else if (i%1000 == 0){
		me = 15;
		if (wsmax < 12000)
		    disp_k(g, i);
            } else if (i%500 == 0) {
                me = 11;
            } else if (i%100 == 0) {
                me = 8;
            } else if (wsmax < 2000){
                me = 5;
            } else
                continue;

	    di = (int)(i*DS);
	    g.setColor(Color.gray);
            g.drawLine(di, HS, di, HS+me);
        }
    }
    public void disp_k(Graphics g, int k) {
        g.setColor(Color.pink);
        g.drawString(k/1000+"k", (int)(DS*k), H);
    }
    //
    public double[] setWaveData() {
	double[] tmp = new double[3];

	tmp[0] = (double)Maxd*sbWide.getValue()/sbWide.getMaximum();
	tmp[1] = (double)Maxd*sbWide.getVisibleAmount()/sbWide.getMaximum();
	tmp[2] = W/tmp[1];
	Time = (tmp[0]+tmp[1]*DW)/SP;

	return tmp;
    }
    public void disp_wave(Graphics g) {
	double[] tmp = setWaveData();
	int stt = (int)tmp[0];
	int wid = (int)tmp[1];
	double dn = tmp[2];
	double val = 200d/getVolume();
	int x, y;

	g.setColor(Color.green);
	for (int i = 0; i < wid; i++) {
	    x = (int)(dn*i);
	    y = (int)(HH-MW.getWave(i+stt)*val);
	    g.drawLine(x, y, x, y);
        }

	disp_time(g, wid);
    }
    public void disp_time(Graphics g, int wid) {
	double tim, allsec = wid/(double)SP;

	if (allsec < 0.1)
            tim = 0.01;
        else if (allsec < 0.3)
            tim = 0.05;
        else if (allsec <= 1)
            tim = 0.1;
        else if (allsec < 3)
            tim = 0.5;
        else if (allsec < 10)
            tim = 1;
        else if (allsec < 30)
            tim = 5;
        else if (allsec < 60)
            tim = 10;
        else
            tim = 60;

        String s = "[sec] ";
        g.setColor(Color.yellow);
        g.drawString(s, W-fm.stringWidth(s), H-FNT*2);

	double asec = tim/(allsec/W);
        int maxsec = (int)(allsec/tim);
        if (maxsec > 0) {
            int ss = H-FNT;  // ʸh
            int x, l = 5;
            for (int i = 0; i <= maxsec; i++) {
                x = (int)(asec*i);

                g.setColor(Color.gray);
                g.drawLine(x, H, x, ss+l);

                g.setColor(Color.yellow);
                g.drawString(dform(i*tim), x, ss);
            }
        }
    }
    public void make_wave() {
	setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR)); // 

	MW.getWaves(SP, Maxp, KN, SEC, make_freq(KN), true);
	MW.getWaves(SP, Maxp, KO, SEC, make_freq(KO), false);

	CalcSW = true;
	setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    }
    public double[] make_freq(int key) {
        double[] freq = new double[Maxp+1];

	for (int i = 1; i <= Maxp; i++)
	    freq[i] = getf(key, i);

	return freq;
    }
    //
    public void disp_cursor(Graphics g) {
	int xn = (int)K[KN].getCenter();
	g.setColor(Color.gray);
	g.drawLine(xn, 0, xn, H-1);
	
	int xo = (int)K[KO].getCenter();
	g.setColor(Color.lightGray);
	g.drawLine(xo, 0, xo, H-1);
    }
    public void disp_c_line(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(0, HH, W-1, HH);
    }
    //
    public void disp_cent(Graphics g) {
	double hb = H/2.5;
	double val = hb/getVolume();
	disp_cline(g, val);

	g.setColor(Color.magenta);
	for (int i = 0; i < KB; i++) {
	    g.fillOval((int)(K[i].getCenter()-Sift),
		       (int)(HH-getc(i, 1)*val),
		       Wide,Wide);
	}
    }
    public void disp_cline(Graphics g, double val) {
       	double dh, hy, cmax = H/val;
	double hx = cmax/10;
        int hp, hm, xs = 2;

        g.setColor(Color.gray);
        g.drawLine(0, HH, W, HH);

        for (int i = 1; i < 6; i++) {
            dh = hx*i;
            hy = val*dh;       // dh & hy
            hp = (int)(HH+hy);
            hm = (int)(HH-hy);

            g.setColor(Color.blue);
            g.drawLine(0, hm, W-1, hm);
            g.drawLine(0, hp, W-1, hp);

            g.setColor(Color.yellow);
            g.drawString(dform(dh), xs+2, hm+FNT);
            g.drawString("-"+dform(dh), xs, hp);
        }
    }
    //
    public void disp_inharmo(Graphics g) {
	int hb = (int)(H/5.0);
	disp_log(g, hb);

	g.setColor(Color.pink);
	for (int i = 0; i < KB; i++) {
	    g.fillOval((int)(K[i].getCenter()-Sift),
		       (int)(HH-hb*log_base(geti(i))),
		       Wide,Wide);
	}
    }
    public void disp_log(Graphics g, int hb) {
        double h0 = 0.001, hl;
        int hm;

        for (int i = 1; i < 6; i++) { // ʿ
            hl = h0*Math.pow(10, i);
            hm = (int)(HH-hb*log_base(hl));

            g.setColor(Color.blue);
            g.drawLine(0, hm, W-1, hm);

            g.setColor(Color.orange); // 
            g.drawString(""+(float)hl, 2, hm);
        }
    }
    public double log_base(double value) {
        return Math.log(value)/Log10;
    }
    //
    public void set_band_width() {
	int dw = (int)K[0].getMinbx();
	int max = 6, min = 3;
	double wd = (dw-2)/2d;
	if (wd < min)
	    wd = min;
	else if (wd > max)
	    wd = max;

	Sift = (wd > 1) ? (int)(wd/2) : 0;
	Wide = (int)wd;
    }
    //
    public void disp_beat(Graphics g) {
	double val = HS/2.0/getVolume();
	double dx = W/(double)Maxp;
	int xs = (int)(dx/2);

	disp_vline(g, dx, xs);
	disp_beat_scale(g, val);

	int x, y, ii, dot = 8, sft = dot/2;
	int R = 255, G = 200; // orange
	double gin;
	for (int i = 0; i < Maxp; i++) {
	    ii = i+1;
	    gin = MW.calc_sindo(getf(KN, ii), ii);
	    g.setColor(new Color(calcColor(R, gin), calcColor(G, gin), 0));

	    x = (int)(dx*i+xs-sft);
	    y = (int)(Math.abs(Unari[i]*val)+sft);

	    g.fillOval(x, HS-y, dot, dot);
	}
    }
    public int calcColor(int co, double val) {
	int sft = 80;  // Ǿ
	int max = 255;

	co *= val;
	co += sft;
	if (co >= max)
	    co = max; 

	return co;
    }
    public void disp_beat_scale(Graphics g, double val) {
        g.setColor(Color.lightGray);
        g.drawLine(0, HS, W, HS);

	double dh, hy, bmax = HS/val;
	double hx = bmax/10;
	int hp, hm, xs = 2;
        for (int i = 1; i <= 10; i++) {
            dh = hx*i;
            hy = val*dh;
            hm = (int)(HS-hy);

            g.setColor(dimGray);
            g.drawLine(0, hm, W-1, hm);

            g.setColor(Color.cyan);
            g.drawString(dform(dh), xs+2, hm+FNT);
        }
    }
    public void disp_vline(Graphics g, double dx, int xs) {
	int x;

	for (int i = 0; i < Maxp; i++) {
	    x = (int)(dx*i+xs);
	    g.setColor(dimGray);
	    g.drawLine(x, 0, x, HS);

	    g.setColor(Color.lightGray);
	    g.drawString(""+(i+1), x, H);
	}
    }
    public void calc_beats() {
	for (int i = 1; i <= Maxp; i++) {
            Slf[i] = getf(KO, i);
            Bgf[i] = getf(KN, i);
        }
	double big = Integer.MAX_VALUE;
	double min, una;
	Minb = big;
	for (int i = 1; i <= Maxp; i++) {
	    min = big;
            for (int j = 1; j <= Maxp; j++) {
		una = Bgf[i]-Slf[j];
		if (Math.abs(min) > Math.abs(una)) // not Math.min
		    min = una;
		if (Math.abs(Minb) > Math.abs(min)) { // not Math.max
		    Minb = min;
		    Minp = i;
		}
	    }
	    Unari[i-1] = min;
	}
    }
    //
    public void disp_keyboard(Graphics g) {
	for (int i = 0; i < KB; i++) {
	    set_key_color(g, i);
	    g.fillPolygon(K[i].getPoly());

	    g.setColor(Color.gray);
	    g.drawPolygon(K[i].getPoly());
	}
    }
    public void set_key_color(Graphics g, int key) {
	if (key == KN)
	    g.setColor(Color.gray);
	else if (key == KO)
	    g.setColor(Color.lightGray);
	else
	    g.setColor(K[key].getColor());
    }
    public void disp_tuning(Graphics g) {
	String mess = "Please wait...";
        int fh = fm.getHeight();
        int fw = fm.stringWidth(mess);
        int x = (W-fw)/2;
        int y = fh*2+20;
        g.setColor(Color.gray);
        g.fill3DRect(x-2, y-fh, fw+4, fh+4, false);
        
        g.setColor(Color.cyan);
        g.drawString(mess, x, y-2);
    }
    //
    public void gauss() {             // window for fft
        double rn = 1d/N, in;
        for (int i = 0; i < N; i++) {
            in = (2d*i-N)*rn;
	    IM[i] = RE[i] = MW.getWave(i)*Math.exp(-4.5*in*in);
        }
    }
    public void initHanning() { // for ifft
        double rn = 1.0/N;

        for (int i = 0; i < N; i++)
            Han[i] = 0.5-0.5*Math.cos(PI2*i*rn);
    }
    public void hanning() { // for ifft
        for (int i = 0; i < N; i++) {
	    IM[i] *= Han[i];
            RE[i] *= Han[i];
        }
    }
    public void fft() { // FFT.java
	fftN.fft(RE, IM);

	for (int i = 0; i < NH; i++)
            DT[i] = Math.sqrt(RE[i]*RE[i]+IM[i]*IM[i]);

	FftSW = true;
    }
}